#ifndef _ASCII_H_
#define _ASCII_H_

//Header file for ASCII art sprites.
#include <header.h>

//Types of Level Layers
#define LEVEL_AARTMAP  2

//Default Values 
#define AART_NULL ' '

struct _aasprite{
	int width;
	int height;	
	unsigned char *data;
	int r,g,b,a;
	int pad;
};

typedef struct _aasprite aasprite;

//Unload ASCII Art
void unload_asciiart(aasprite *);

//Create ASCII Art
aasprite *create_asciiart(int, int);

//Load ASCII Art from a preopened file
aasprite *load_asciiart_file(FILE *);

#define aamap aasprite
#define unload_asciimap unload_asciiart
#define create_asciimap create_asciiart
#define load_asciimap_file load_asciiart_file

#endif //_ASCII_H_