#ifndef _GAMESTATE_H_
#define _GAMESTATE_H_

//Header file for Game States.

#include <header.h>
#include <game.h>

#define GAME_USUAL -1	
#define GAME_PLAY 0
#define GAME_LOST 1
#define GAME_WIN  2
#define GAME_MENU 3
#define GAME_CREDITS 4
#define GAME_HELP 5

extern int oldstate;
extern int state;

//During GamePlay
void game_play_init();
void game_play_logic();
void game_play_input();
void game_play_render();
void game_play_quit();

//During GameOver
void game_lost_init();
void game_lost_logic();
void game_lost_input();
void game_lost_render();
void game_lost_quit();

//During GameWin
void game_win_init();
void game_win_logic();
void game_win_input();
void game_win_render();
void game_win_quit();

//During GameMenu
void game_menu_init();
void game_menu_logic();
void game_menu_input();
void game_menu_render();
void game_menu_quit();

//During GameCredits
void game_credits_init();
void game_credits_logic();
void game_credits_input();
void game_credits_render();
void game_credits_quit();

//During GameHelp
void game_help_init();
void game_help_logic();
void game_help_input();
void game_help_render();
void game_help_quit();

//Usual Unimplemented
void usual_init();
void usual_logic();
void usual_input();
void usual_render();
void usual_quit();

//Init for States
void state_init();

//Logic for States
void state_logic();

//Input for States
void state_input();

//Render for States
void state_render();

//Switch to State
void state_switch(int newstate);

//Quit for States
void state_quit();

//Quit for States
void terminate_state_loop();

#endif //_GAMESTATE_H_
