//Source file for ASCII functions.

#include <ascii.h>
#include <log.h>
#include <util.h>

//Unload ASCII Art
void unload_asciiart(aasprite *givaaspr){
	if(givaaspr){
		//Remove Data
		if(givaaspr->data) free(givaaspr->data);
		givaaspr->data=NULL;
		givaaspr->r=0; givaaspr->g=0; givaaspr->b=0; givaaspr->a=0; 
		givaaspr->width=0; givaaspr->height=0; 
		#ifdef VERBOSE
			log_printf("Freed ASCIIArt");
		#endif //VERBOSE
		free(givaaspr);	
	}
}

//Create ASCII Art
aasprite *create_asciiart(int width, int height){
	int allocsizedata=0;
	aasprite *newaaspr=NULL;

	if(width<=0||height<=0) return newaaspr;

	newaaspr=malloc(sizeof(aasprite));	
	if(newaaspr) {
		newaaspr->width=width;
		newaaspr->height=height;
		newaaspr->r=0; newaaspr->g=0; newaaspr->b=0; newaaspr->a=0; 
		allocsizedata=sizeof(unsigned char)*newaaspr->width*newaaspr->height;
		newaaspr->data=malloc(allocsizedata);
		if(newaaspr->data) {
			memset(newaaspr->data,AART_NULL,allocsizedata); 
		}	
		else {
			unload_asciiart(newaaspr); newaaspr=NULL;
		}
	}
	#ifdef VERBOSE
		if(newaaspr) log_printf("Created ASCIIArt: %dx%d",newaaspr->width,newaaspr->height);
	#endif //VERBOSE
	return newaaspr;
}

//Load ASCII Art from a preopened file
aasprite *load_asciiart_file(FILE *fascii){
	int width=0,height=0;
	int c;
	int i,j,l,lscanned;
	int r=0,g=0,b=0,a=0;
	char data[MAXSTR];
	aasprite *newaaspr=NULL;

	fscanf(fascii,"%d%d",&width,&height);

	newaaspr=create_asciiart(width,height);
	if(!newaaspr) return newaaspr;

	fscanf(fascii,"%d%d%d",&r,&g,&b);
	
	newaaspr->r=r; newaaspr->g=g; newaaspr->b=b; newaaspr->a=255;

	for(l=0,i=0;i<newaaspr->height;++i){	

		//Special Version of NewLine
		while(c!=EOF&&c!='\r'&&c!='\n')	{c=fgetc(fascii);}
		if(c!=EOF&&c!='\r'&&c!='\n') ungetc(c,fascii);

		lscanned=0;
		for(j=0;!lscanned&&j<newaaspr->width;++j){
			c=fgetc(fascii);
			if(isprint(c)&&c!=' ') 
				*((newaaspr->data)+l)=(unsigned char)c;
			if(c=='\r'||c=='\n') {
				++lscanned; 
				l+=newaaspr->width-j-1;
			}
			++l;
		}
	}

	#ifdef VERBOSE
		log_printf("Loaded ASCIIArt");		
	#endif //VERBOSE	

	return newaaspr;
}
