//Source file for Credits.

#include <header.h>
#include <global.h>
#include <gameglobal.h>
#include <game.h>
#include <gamestate.h>

//Credits Types
#define CREDITS_TITLE 0
#define CREDITS_SUBTITLE 1
#define CREDITS_NORMAL 2
#define CREDITS_SPECIAL 3

//Number of Credits Lines
#define CREDITS_LINES 50

//For Scrolling
int xpos=0,ypos=0;
int xcursor,ycursor;
int credits_done=0;

//ASCII Sprites 
aasprite *aawinbg=NULL;

//Credits Lines Type
int cred_types[CREDITS_LINES]=
{
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_TITLE,
CREDITS_NORMAL,
CREDITS_TITLE,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_SUBTITLE,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_SUBTITLE,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_SUBTITLE,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_SPECIAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL,
CREDITS_NORMAL
};

//Credits Lines Values
char cred_strings[CREDITS_LINES][MAXSTR]=
{
"",
"",
"",
"",
"",
"",
"ASCII Trains",
"",
"was made in Allegro",
"",
"",
"",
"",
"",
"",
"Programmed By",
"",
"guilt",
"",
"",
"",
"",
"",
"",
"Designed By",
"",
"guilt",
"",
"",
"",
"",
"",
"",
"Many Thanks to",
"",
"Allegro Developers",
"#allegro",
"",
"",
"",
"",
"",
"",
"Thank you for playing"
"",
"",
"",
"",
"",
""
};

//Credits Initialization
void game_credits_init(){
	char aafilename[MAXSTR],filename[MAXSTR],typename[MAXSTR];
	FILE *fascii=NULL;

	strcpy(typename,"Game");

	strcpy(filename,"win.txt");
	*aafilename=0;				
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aawinbg=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}

	xpos=(dbuffer->w+(aawinbg->width*xmul))/2;
	ypos=dbuffer->h;
	credits_done=0;
}

//Credits Scrolling Logic
void game_credits_logic(){
	ypos--;
	if((ypos+(CREDITS_LINES*ymul))<=0) ++credits_done;
	if(credits_done) state_switch(GAME_MENU);
}

//Credits Input
void game_credits_input(){
	if(key[KEY_ESC]) ++credits_done;
}

//Render Credits
void game_credits_render(){
	int i;
	
	//Clear 
	clear_to_color(dbuffer,makecol(220,220,220));

	//Initialize
	xcursor=xpos;
	ycursor=ypos;

	//Draw Won Sprite
	draw_asciiart(dbuffer, aawinbg, 0, 0 );

	//Draw 'em
	for(i=0;i<CREDITS_LINES;++i){
		if(cred_types[i]==CREDITS_TITLE) 
			textout_centre_ex(dbuffer, font, cred_strings[i], xcursor, ycursor, makecol(240,160,96), -1);
		else if(cred_types[i]==CREDITS_SUBTITLE) 
			textout_centre_ex(dbuffer, font, cred_strings[i], xcursor, ycursor, makecol(255,0,0), -1);
		else if(cred_types[i]==CREDITS_NORMAL) 
			textout_centre_ex(dbuffer, font, cred_strings[i], xcursor, ycursor, makecol(32,32,32), -1);
		else if(cred_types[i]==CREDITS_SPECIAL) 
			textout_centre_ex(dbuffer, font, cred_strings[i], xcursor, ycursor, makecol(0,192,192), -1);
		ycursor+=ymul;
	}		
}

//Quit Credits
void game_credits_quit(){
	xpos=0;
	ypos=0;
	credits_done=0;	

	if(aawinbg) unload_asciiart(aawinbg);
	aawinbg=NULL;
}