//Source file for Help.

#include <header.h>
#include <global.h>
#include <game.h>
#include <gamestate.h>
#include <gameglobal.h>

#define HELP_LINES 25

//Help Lines Values
char help_strings[HELP_LINES][MAXSTR]=
{
"Hi! Welcome to ASCIITrain.",
"",
"You are Mr. Stick, a stick figure, living in ASCII_land. You",
"love trains. In fact, you like them so much, that you like to hop",
"on their top.",
"",
"",
"It so happens that there's a new train hopping competition",
"around the corner. And you are about to get some serious",
"practise ...",
"",
"",
"... which is where we come in.",
"",
"",
"You start on one end of a train, and move on to the other end. Use",
"the RIGHT arrow key to go right, and SPACE to Jump. Time left to complete",
"the level is shown on the upper corner of the screen. Rush fast enough",
"to beat the scrolling camera.",
"",
"",
"Do you have it in you? ASCIITrain awaits ...",
"",
"",
"Press F1 during game for this help. Now press Q to close."
};

//Help Initialize
void game_help_init(){
}

//Help Logic
void game_help_logic(){
}

//Help Input
void game_help_input(){
	int k=-1;
	if(!keypressed()) return;

	k=readkey(); k>>=8;

	if(k==KEY_Q) state_switch(oldstate);
}

//Help Render
void game_help_render(){
	int i;
	int xcursor=40,ycursor=60;

	//Clear 
	clear_to_color(dbuffer,makecol(220,220,220));

	//Help
	textout_centre_ex(dbuffer, font, "Help", dbuffer->w/2, 20, makecol(255,0,0), -1);

	//Draw 'em
	for(i=0;i<HELP_LINES;++i){
		textout_ex(dbuffer, font, help_strings[i], xcursor, ycursor, makecol(32,32,32), -1);
		ycursor+=(2*ymul);
	}		

}

//Help Quit
void game_help_quit(){
}